package ru.dbotthepony.kstarbound.test

import org.junit.jupiter.api.Assertions.*
import org.junit.jupiter.api.DisplayName
import org.junit.jupiter.api.Test
import ru.dbotthepony.kstarbound.util.ArraySpliterator
import java.rmi.UnexpectedException

object MiscTests {
	@Test
	@DisplayName("Array Spliterator test")
	fun arraySpliterator() {
		val base = arrayOf(1, 2, 3, 4)
		val spliterator = ArraySpliterator(base)

		assertTrue(spliterator.tryAdvance { assertEquals(1, it) })
		assertTrue(spliterator.tryAdvance { assertEquals(2, it) })
		assertTrue(spliterator.tryAdvance { assertEquals(3, it) })
		assertTrue(spliterator.tryAdvance { assertEquals(4, it) })
		assertFalse(spliterator.tryAdvance { throw UnexpectedException("Unreachable code") })
	}

	@Test
	@DisplayName("Array Spliterator split test")
	fun arraySpliteratorSplit() {
		val base = arrayOf(1, 2, 3, 4, 5, 6)
		val spliterator = ArraySpliterator(base)

		var i = 0

		val splitted = spliterator.trySplit()!!

		splitted.forEachRemaining { assertEquals(++i, it) }
		spliterator.forEachRemaining { assertEquals(++i, it) }

		assertEquals(6, i)
	}
}
